#include <iostream>
#include <fstream>
#include <cstring>
using namespace std;

const int MAXS = 20;
const int RIG = 10;
const int COL = 4;
const int MAXV = 30;

struct Volo {
  int codice; 
  char partenza[MAXS];
  char destinazione[MAXS];
  bool posti[RIG][COL];
};

struct ArchivioVoli{
  Volo vol[MAXV];
  int numVoli;
};

void stampaVolo(const ArchivioVoli* pa, int c);
void stampaFrazioni(const ArchivioVoli* pa);
bool prenota(ArchivioVoli* pa, int c, int* pr, int* pc);
bool carica(ArchivioVoli* pa, const char nomf[]);
int rimuovi(ArchivioVoli* pa, const char p[], const char d[]);

void menu(){
  cout << "\n\n--------------------" << endl;
  cout << "1) carica" << endl;
  cout << "2) stampa volo" << endl;
  cout << "3) prenota" << endl;
  cout << "4) stampa frazioni" << endl;
  cout << "5) rimuovi" << endl;
  cout << "6) stampa" << endl;
  cout << "7) esci" << endl;
  cout << "? ";
}

int main(){
  ArchivioVoli ar;
  ar.numVoli = 0;
  char s;
  bool res;
  int cod;
  int r, c, k;
  char s1[MAXS], s2[MAXS];

  while(true) {
    menu();
    cin >> s;
    switch(s) {
      case '1': 
        res = carica(&ar, "ingresso.txt");
        if(res) cout << "Caricamento ok" << endl;
        else cout << "Problema durante il caricamento" << endl;
        break;
      case '2':
        cout << "Codice volo? ";
        cin >> cod;
        stampaVolo(&ar, cod);
        break;
      case '3':
        cout << "Codice volo? ";
        cin >> cod;
        res = prenota(&ar, cod, &r, &c);
        if(res) cout << "Ho prenotato il posto " << r << ", " << c << endl;
        else cout << "Posto non prenotato" << endl;
        break;
      case '4':
        stampaFrazioni(&ar);
        break;
      case '5':
        cout << "Sottostringa partenza? ";
        cin >> s1;
        cout << "Sottostringa arrivo? ";
        cin >> s2;
        k = rimuovi(&ar, s1, s2);
        cout << "Ho rimosso " << k << " voli" << endl;
        break;
      case '6':
        cout << "Voli presenti:" << endl;
        for(int i=0; i<ar.numVoli; i++)
          cout << ar.vol[i].codice << '\t' << ar.vol[i].partenza << '\t' << ar.vol[i].destinazione << endl;
        break;
      case '7':
        return 0;
    }
  }
}
