#include <iostream>
#include <fstream>
#include <cstring>
#include <cmath>
using namespace std;

const int MAXS = 20;
const int RIG = 10;
const int COL = 4;
const int MAXV = 30;

struct Volo {
  int codice; 
  char partenza[MAXS];
  char destinazione[MAXS];
  bool posti[RIG][COL];
};

struct ArchivioVoli{
  Volo vol[MAXV];
  int numVoli;
};

void stampaVolo(const ArchivioVoli* pa, int c) {
  for(int i=0; i<pa->numVoli; i++)
    if(pa->vol[i].codice == c) {
      cout << c << '\t' << pa->vol[i].partenza << '\t' << pa->vol[i].destinazione << endl;
      for(int r=0; r<RIG; r++) {
        for(int c=0; c<COL; c++) 
          cout << (pa->vol[i].posti[r][c] ? 'L' : 'O');
        cout << endl;
      }
    }
}

float calcolaFrazione(const Volo* pv) {
  float q = 0;
  for(int r=0; r<RIG; r++)
    for(int c=0; c<COL; c++)
      if(!pv->posti[r][c])
        q++;
  return  q/(RIG*COL);
}

void stampaFrazioni(const ArchivioVoli* pa) {
  for(int i=0; i<pa->numVoli; i++) {
    cout << pa->vol[i].codice << '\t' << calcolaFrazione(&pa->vol[i]) << endl;
  }
}

bool prenota(ArchivioVoli* pa, int c, int* pr, int* pc) {
  for(int i=0; i<pa->numVoli; i++) {
    if(pa->vol[i].codice == c) {
      for(int r=0; r<RIG; r++)
        for(int c=0; c<COL; c++) 
          if(pa->vol[i].posti[r][c]) {
            pa->vol[i].posti[r][c] = false;
            *pr = r;
            *pc = c;
            return true;
          }
      return false;
    }  
  }
  return false;
}

bool carica(ArchivioVoli* pa, const char nomf[]) {
  fstream f;
  f.open(nomf, ios::in);
  if(!f)
    return false;
  Volo v;
  while(f >> v.codice >> v.partenza >> v.destinazione) {
    for(int r=0; r<RIG; r++)
      for(int c=0; c<COL; c++) 
        v.posti[r][c] = true;
    pa->vol[pa->numVoli++] = v;
  }
  return true;
}

bool daRimuovere(const char vp[], const char vd[], const char p[], const char d[]) {
  return strstr(vp, p) > 0 && strstr(vd, d) > 0;
}

int rimuovi(ArchivioVoli* pa, const char p[], const char d[]) {
  int conta = 0;
  for(int i=0; i<pa->numVoli; i++) {
    if(daRimuovere(pa->vol[i].partenza, pa->vol[i].destinazione, p, d)) {
      pa->vol[i] = pa->vol[--pa->numVoli];
      conta++;
      i--;
    }
  }
  return conta;
}

